/*
  EZinst - Easy Installation -
  Copyright (C) 1993, 1994, 1995 Takashi MANABE
                                     (manabe@Roy.dsl.tutics.tut.ac.jp)

  EZinst is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */
#include <stdio.h>
#include "label.h"

#if 0
ListUpLabel(struct labelLink *head)
{
    struct labelLink *llp;

    for (llp = head; llp != NULL; llp = llp->next)
	printf("name=%s value=%d\n", llp->name, llp->value);
}
#endif

static bool EvalLine(struct labelLink *llp, bool check)
{
    bool stack[100], tmp;
    int sp, i;

    for (sp = i = 0; i < MAX_CODE; i ++) {
	switch(llp->code[i].type) {
	case TYPE_NUMBER:
	    stack[sp] = llp->code[i].v.num;
	    sp ++;
	    break;
	case TYPE_LABEL:
	    if (llp->code[i].v.lbl == NULL)
		stack[sp] = check;
	    else
		stack[sp] = llp->code[i].v.lbl->value;
	    sp ++;
	    break;
	case TYPE_OP:
	    switch(llp->code[i].v.op) {
	    case OP_OR:
		sp --;
		tmp = stack[sp] | stack[sp - 1];
		stack[sp - 1] = tmp;
		break;
	    case OP_AND:
		sp --;
		tmp = stack[sp] & stack[sp - 1];
		stack[sp - 1] = tmp;
		break;
	    case OP_NOT:
		tmp = !stack[sp - 1];
		stack[sp - 1] = tmp;
		break;
	    case OP_END:
		llp->value = stack[0];
		return(stack[0]);
	    }
	    break;
	}
    }
}

int Eval(struct labelLink *head)
{
    struct labelLink *llp;
    int size;
    bool tret, fret;

    for (llp = head; llp != NULL; llp = llp->next) {
	tret = EvalLine(llp, TRUE);
	fret = EvalLine(llp, FALSE);
	llp->able = (tret == fret) ? FALSE: TRUE;
	llp->value = (llp->selected == TRUE) ? tret: fret;
/*	printf("name=%s value=%d/%d\n", llp->name, tret, fret);*/
    }
    return(size);
}
