/*
  EZinst - Easy Installation -
  Copyright (C) 1993, 1994, 1995 Takashi MANABE
                                     (manabe@Roy.dsl.tutics.tut.ac.jp)

  EZinst is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "buffer.h"
#include "label.h"

static struct labelLink *_labelHead;
static int _maxLabels = 0;
int yylines;

static struct labelLink *NewLabel(char *name)
{
    static struct labelLink *tail;
    struct labelLink *llp;

    NEW_LINK(struct labelLink, _labelHead, tail, llp);
    llp->name = strdup(name);
    _maxLabels++;
    return(llp);
}

int LoadIntoLabel(char *name, struct labelLink **head)
{
    extern FILE *yyin;

    _maxLabels = 0;
    if ((yyin = fopen(name, "r")) == NULL) {
	perror(name);
    } else {
	yylines = 1;
	if (yyparse() > 0) {
	    fprintf(stderr, "Error in %d!!\n", yylines);
	    _maxLabels = 0;
	    *head = NULL;
	} else *head = _labelHead;
	fclose(yyin);
    }
    return(_maxLabels);
}

struct labelLink *GetLabelFromName(char *name)
{
    static struct labelLink *llp;

    for (llp = _labelHead; llp != NULL; llp = llp->next)
	if (!strcmp(llp->name, name)) break;
    if (llp == NULL) llp = NewLabel(name);
    return(llp);
}
