/*
  EZinst - Easy Installation -
  Copyright (C) 1993, 1994, 1995 Takashi MANABE
                                     (manabe@Roy.dsl.tutics.tut.ac.jp)

  EZinst is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */

#include <stdio.h>
#include <nl_types.h>
#include "label.h"
#include "paths.h"

extern bool japanese;
static nl_catd catFd;

int InitMessage()
{
    if ((catFd = catopen((japanese ? FILE_JAPANESE:FILE_ENGLISH),
			 MCLoadBySet)) < 0) {
	perror((japanese ? FILE_JAPANESE:FILE_ENGLISH));
	return(-1);
    }
    return(0);
}

char *GetCatalog(int set, int mess)
{
#if 0
    char *p;
    p = catgets(catFd, set, mess, "");
    mvprintw(20, 0, "<%d:%s>\n", mess, p);
    refresh();
    return(p);
#else
    return(catgets(catFd, set, mess, ""));
#endif
}

void CloseMessage()
{
    catclose(catFd);
}
