/*
  EZinst - Easy Installation -
  Copyright (C) 1993, 1994, 1995 Takashi MANABE
                                     (manabe@Roy.dsl.tutics.tut.ac.jp)

  EZinst is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */

#include <stdio.h>
#include <string.h>
#include "paths.h"
#include "label.h"
#include "screen.h"
#include "menu.h"
#include "buffer.h"
#include "message.h"
#include <jcurses.h>

extern int categoryLabels, packageLabels;
extern struct labelLink *labelHead;

/* navigator */

static int InputMethod()
{
    int ret;
    struct menuLink *mlp, *tail, *head;

    head = tail = NULL;
    NEW_LINK(struct menuLink, head, tail, mlp);
    mlp->p.lbl = GetLabelFromName("CANNA");
    mlp->desc = mlp->p.lbl->name;
    mlp->key = ' ';
    mlp->able = TRUE;
    NEW_LINK(struct menuLink, head, tail, mlp);
    mlp->key = ' ';
    mlp->able = TRUE;
    mlp->p.lbl = GetLabelFromName("WNN");
    mlp->desc = mlp->p.lbl->name;
    NEW_LINK(struct menuLink, head, tail, mlp);
    mlp->key = ' ';
    mlp->able = TRUE;
    mlp->p.lbl = GetLabelFromName("SJ3");
    mlp->desc = mlp->p.lbl->name;
    ret = SelectWin(GetMessage(MSG_NAVI_JIM_DESC), head,
		       GetMessage(MSG_NAVI_JIM_TITLE), 66, SELECT_RULE);
    DEL_LINK(struct menuLink, head);
    return(ret);
}

static int Editor()
{
    int ret;
    struct menuLink *mlp, *tail, *head;

    head = tail = NULL;
    NEW_LINK(struct menuLink, head, tail, mlp);
    mlp->key = ' ';
    mlp->able = TRUE;
    mlp->p.lbl = GetLabelFromName("MULE");
    mlp->desc = mlp->p.lbl->name;
    NEW_LINK(struct menuLink, head, tail, mlp);
    mlp->key = ' ';
    mlp->able = TRUE;
    mlp->p.lbl = GetLabelFromName("JVIM");
    mlp->desc = mlp->p.lbl->name;
    ret = SelectWin(GetMessage(MSG_NAVI_JIM_DESC), head,
		       GetMessage(MSG_NAVI_JIM_TITLE), 66, SELECT_RULE);
    DEL_LINK(struct menuLink, head);
    return(ret);
}

int StartMessage()
{
    MessageWin(GetMessage(MSG_NAVI_START), "", 0);
    return(0);
}

static int (*NavigatorFuncs[])() = {
    StartMessage,
    InputMethod,
    Editor,
    NULL
};

int NaviStart(struct menuLink *pmp)
{
    int i=0;

    while(NavigatorFuncs[i]) {
	if (NavigatorFuncs[i]() == -1 && i > 0) i --;
	else i ++;
    }
    return(0);
}
