/*
  EZinst - Easy Installation -
  Copyright (C) 1993, 1994, 1995 Takashi MANABE
                                     (manabe@Roy.dsl.tutics.tut.ac.jp)

  EZinst is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */

%%
[01]		{
			yylval.number=atoi(yytext);
			return(NUMBER);
		}
[@$0-9a-zA-Z]*	{
			yylval.link = (struct labelLink *)
			    GetLabelFromName(yytext);
			return(LABEL);
		}
"?"		{
			yylval.link = NULL;
			return(LABEL);
		}
"\n"		return(NL);
"!"		return(NOT);
"|"		return(OR);
"&"		return(AND);
"("		return(LBRACKET);
")"		return(RBRACKET);
"="		return(STORE);
[ \t]		;
.		return(yytext[0]);
%%
