/*
  EZinst - Easy Installation -
  Copyright (C) 1993, 1994, 1995 Takashi MANABE
                                     (manabe@Roy.dsl.tutics.tut.ac.jp)

  EZinst is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  */

%{
#include <stdio.h>
#include "label.h"
static struct codeRec code[MAX_CODE];
static int codeCount=0;
extern int yylines;
%}
%union {
    bool number;
    struct labelLink *link;
}

%token	<number>	NUMBER
%token	<link>		LABEL
%token	NL
%token	STORE
%token	LBRACKET
%token	RBRACKET
%left	OR
%left	AND
%right	NOT
%type	<number>	expr
%%
s	: list
	;
list	: /* empty */
	| list LABEL STORE expr NL	{
	    code[codeCount].type = TYPE_OP;
	    code[codeCount].v.op = OP_END;
	    codeCount ++;
	    memcpy($2->code, code, sizeof(struct codeRec) * codeCount);
	    codeCount = 0;
	    yylines ++;
	}
	;
expr
	: expr OR expr	{
	    code[codeCount].type = TYPE_OP;
	    code[codeCount].v.op = OP_OR;
	    codeCount ++;
	}
	| expr AND expr	{
	    code[codeCount].type = TYPE_OP;
	    code[codeCount].v.op = OP_AND;
	    codeCount ++;
	}
	| NOT expr	{
	    code[codeCount].type = TYPE_OP;
	    code[codeCount].v.op = OP_NOT;
	    codeCount ++;
	}
	| LBRACKET expr RBRACKET	{}
	| NUMBER	{
	    code[codeCount].type = TYPE_NUMBER;
	    code[codeCount].v.num = $1;
	    codeCount ++;
	}
	| LABEL	{
	    code[codeCount].type = TYPE_LABEL;
	    code[codeCount].v.lbl = $1;
	    codeCount ++;
	}
	;
%%

#include "lex.yy.c"
